/***********************************************
*  FreeRTOS Test Program sample3
*  Queue Control
***********************************************/
#include <p24FJ128GA010.h>
#include "FreeRTOS.h"					/* FreeRTOSwb_ */
#include "task.h"
#include "queue.h"
#include <Lcd_Lib32.h>
/***  RtBM[Vݒ  ***/
_CONFIG1(JTAGEN_OFF & GCP_OFF & GWRP_OFF & BKBUG_OFF & COE_OFF & FWDTEN_OFF & ICS_PGx2) 
// 8MHz*PLL4=32MHz (Full Speed)
_CONFIG2(IESO_OFF & FCKSM_CSDCMD & OSCIOFNC_OFF & POSCMOD_HS & FNOSC_PRIPLL)

/* ϐ`*/
xQueueHandle lcdQueue;
/* ֐vg */
void vTask1( void *pvParameters );		// ^XNP
void vTask2( void *pvParameters );		// ^XNQ
void vTask3( void *pvParameters );		// ^XNR
void itostring(char digit, unsigned int data, char *buffer);

/****************** C֐ ************************/
int main(void){
	/* VXeݒ */
	AD1PCFG = 0xFFFF;						// ׂăfW^I/O
	LATA = 0;							// I/Oݒ
	TRISA = 0;
	// LCD̏ݒƏ\
	TRISE = 0;							// LCDp
	TRISDbits.TRISD4 = 0;					// LCDp
	TRISDbits.TRISD5 = 0;					// LCDp
	LCD_WR = 0;							// WR͏Low
	TRISBbits.TRISB15 = 0;					// LCDp
	lcd_init();							// LCD
	lcd_clear();							// S
	lcd_str("Start!");					// JnbZ[W
	delay_ms(500);						// 0.5secԕ\
	/* L[obt@@*/
	lcdQueue = xQueueCreate(5, 17);			// 17Byte x 5
	/* ^XN  */
	xTaskCreate( vTask1, (signed portCHAR *)"T1", 100, NULL, 1, NULL );
	xTaskCreate( vTask2, (signed portCHAR *)"T2", 100, NULL, 1, NULL );
	xTaskCreate( vTask3, (signed portCHAR *)"T3", 100, NULL, 1, NULL );
	/* XPW[OJn@*/
	vTaskStartScheduler();  
	/********@C[v  *******/
	while(1)
	{	}
}

/***** ^XN1֐ ******/
void vTask1(void *pvParameters){
	static char Msg1[] = "Task1Count=xxxxx";
	static unsigned int Count1 = 0;

	while(1) {
		LATA ^= 0x80;
		itostring(5, Count1, Msg1+11);			// bZ[Wp
		Count1++;
		/* L[ɓo^ */
		xQueueSendToBack(lcdQueue, Msg1, portMAX_DELAY);
		vTaskDelay(200 / portTICK_RATE_MS);		// 100msec҂
	}
}
/***** ^XN2֐ ******/
void vTask2(void *pvParameters){
	static char Msg2[] = "Task2Count=xxxxx";
	static unsigned int Count2 = 0;

	while(1)	{
		LATA ^= 0x40;
		itostring(5, Count2, Msg2+11);			// bZ[Wp
		Count2++;
		/* L[ɓo^ */
		xQueueSendToBack(lcdQueue, Msg2, portMAX_DELAY);   
		vTaskDelay(400 / portTICK_RATE_MS);		// 200msec҂
	}
}
/***** ^XN3֐ ******/
void vTask3(void *pvParameters){
	char Buf[32];

	while(1) {
		LATA ^= 0x20;
		/* L[f[^o */
		xQueueReceive(lcdQueue, Buf, portMAX_DELAY);
		// bZ[WLCD\
		if(Buf[4] == '1')
			lcd_cmd(0x80);				// 1sڂ
		else
			lcd_cmd(0xC0);				// 2sڂ
		lcd_str(Buf);						// \s
	}
}

/*****************************************
*   l當ɕϊ
*****************************************/
void itostring(char digit, unsigned int data, char *buffer)
{
	char i;
	buffer += digit;						//̍Ō
	for(i=digit; i>0; i--) {				//ŉʌʂ
		buffer--;						//|C^[P
		*buffer = (data % 10) + '0';		//̌l𕶎ɂĊi[
		data = data / 10;					//-1
	}
}
